searchNodes=[{"doc":"usage: defmodule MyParser do use ParserBuilder , file : &quot;path_to_my_grammar.xml&quot; end","ref":"ParserBuilder.html","title":"ParserBuilder","type":"module"},{"doc":"ParserBuilder is a library that allows you to simply generate a resumable parser with unlimited backtracking from an easily modifiable grammar (expressed in XML). What sets this parser library apart from others is that you don't define your parser by expressing the grammar and rules in Elixir code but rather in a single XML file. I've personally used this approach for an ABNF grammar with 460+ rules and added postprocessing , such as tagging, ignoring and replacing values, or any combination there of, as needed in the XML file instead of Elixir code.","ref":"readme.html","title":"ParserBuilder","type":"extras"},{"doc":"unlimited backtracking. resumable parsing, in case that the input cannot be provided in one piece. overridable rules. If some rules can only be known at runtime, you can override the rules from the grammar. easily add postprocessing, such as tagging, ignoring and replacing intermediate parse results.","ref":"readme.html#features","title":"ParserBuilder - Features","type":"extras"},{"doc":"defmodule MyParser do use ParserBuilder , file : &quot;priv/my_grammar.xml&quot; end This will inject the following functions into your MyParser module: parse_string(rule_name, string), calls parse_string_non_strict(rule_name, string) parse_string_strict(rule_name, string) parse_string_non_strict(rule_name, string)","ref":"readme.html#usage","title":"ParserBuilder - Usage","type":"extras"},{"doc":"&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; ?&gt; &lt;grammar xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot; xsi:noNamespaceSchemaLocation=&quot;../abnf.xsd&quot;&gt; &lt;rule id=&quot;simple1&quot;&gt; &lt;cs_literal value=&quot;one&quot;/&gt; &lt;/rule&gt; &lt;/grammar&gt; use the above grammar in the MyParser module and call { :continue , cont1 } = MyParse . parse_string ( &quot;simple1&quot; , &quot;on&quot; ) { :done , { :ok , [ &quot;one&quot; ] , &quot;rest&quot; } } = cont1 . ( &quot;erest&quot; ) if you want the parser to fail if it does not consume the entire input use the following function instead: { :continue , cont1 } = MyParse . parse_string_strict ( &quot;simple1&quot; , &quot;on&quot; ) { :done , { :error , _reason } } = cont1 . ( &quot;erest&quot; ) { :done , { :ok , [ &quot;one&quot; ] , &quot;&quot; } } = cont1 . ( &quot;e&quot; ) This library features the following &quot;xmlized&quot; abnf combinators: &lt;optional&gt;...&lt;/optional&gt; &lt;many&gt;...&lt;/many&gt; &lt;manyOne&gt;...&lt;/manyOne&gt; &lt;oneOf&gt;&lt;item&gt;...&lt;/item&gt;...&lt;/oneOf&gt; (backtracking included) &lt;atMost count=&quot;3&quot;&gt;...&lt;/atMost&gt; &lt;atLeast count=&quot;2&quot;&gt;...&lt;/atLeast&gt; &lt;exactly count=&quot;2&quot;&gt;...&lt;/exactly&gt; &lt;repeat min=&quot;1&quot; max=&quot;5&quot;&gt;...&lt;/repeat&gt; and the following &quot;primitives&quot;: &lt;cs_literal value=&quot;some&quot;/&gt; ( c ase s ensitive) &lt;ci_literal value=&quot;else&quot;/&gt; ( c ase i nsensitive, explicit) &lt;literal value=&quot;else&quot;/&gt; ( c ase i nsensitive, implicit) and a number of result aggregation features inspired by and shamelessly copied from nimble_parsec: &lt;tag name=&quot;tag1&quot;&gt;...&lt;/tag&gt; &lt;ignore&gt;...&lt;/ignore&gt; &lt;replace value=&quot;replacement&quot;&gt;...&lt;/replacement&gt; &lt;untagAndFlatten&gt;...&lt;/untagAndFlatten&gt; Named rules from the top level are referenced like this: &lt;ruleRef uri=&quot;nameOfTheRule&quot;/&gt; For a more comprehensive demonstration of this library's features please have a look at the tests. The schema file for this version can be found here: abnf.xsd","ref":"readme.html#examples","title":"ParserBuilder - Examples","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding parser_builder to your list of dependencies in mix.exs : def deps do [ { :parser_builder , &quot;~&gt; 1.0.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/parser_builder .","ref":"readme.html#installation","title":"ParserBuilder - Installation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog for ParserBuilder","type":"extras"},{"doc":"Enhancements added convenience functions from_rule_name() and siblings, and finalize()","ref":"changelog.html#v1-1-0","title":"Changelog for ParserBuilder - v1.1.0","type":"extras"},{"doc":"First release.","ref":"changelog.html#v1-0-0","title":"Changelog for ParserBuilder - v1.0.0","type":"extras"}]